%%
clear all; clc;
% temperature_type = 'max';
temperature_type = 'min';
Threshold = [ -3 ]';           % Unit : Standard Scores
Searching_radius = [ 1 ]'; % Unit : Geographical Degree
Complex = []; N = 0;
for k = 1:size(Threshold , 1 );
    N = N+1;
    Complex{k} = Quality_Control_To_Ensure_Station_Temperature_Data_97_12_02( Threshold(k) , Searching_radius(k) , N , temperature_type);
    disp(k);
end

%% Mapping suspicious data to reaveal the reality....x
cd('E:\University_Funded_Project_97_11_10\My_Developed_M_Files_Isfahan_Funded_Project_97_11_20');
if strcmp(temperature_type , 'max')==1;
    Str = 'max temp';
    load('Standard_Scores_Max_Temp_97_12_16.mat');
    Data = tmax;
elseif  strcmp(temperature_type , 'min')==1;
    Str = 'min temp';
    load('Standard_Scores_Min_Temp_97_12_16.mat');
    Data = tmin;
    disp([ 'Min_Temp_Loaded....' ]);
end
load('Ostan_Borders_97_08_25.mat');
Pos = pos;
Doubted_Bank = [];
for i = 1:size(Complex , 2 );
    data = Complex{i};
    % % % %  Cxa = sign(data( : , 11 ))~=sign(Threshold) & data( : , 10 )>=1;
    Cxa = data( : , 13)>=4 & data( : , 11)>=1;
    Aa = data( Cxa , : );
    if sign(Threshold)==1;  File_Name = 'Extreme_Hot_Temperature_Records_0';   end;
    if sign(Threshold)==-1; File_Name = 'Extreme_Cold_Temperature_Records_0'; end;
    load([ File_Name int2str(N) '.mat' ] , 'Distance_Box' );
    dis_matrix = (Distance_Box( 1 , Cxa ));
    Doubted_Bank{i} = Aa;
    nn = 0; info_box = []; 
    for j = 1:size(Aa , 1 );
        posr = Pos( Aa( j , 10 ) , : );
        Cola = find(dis_matrix{ 1 , j }<=Searching_radius(i));
        all = [ Pos( Cola , : ) , Z_Scores( Aa( j , 7 ) , Cola)' ];
        
        sub_date = Date( Aa( j , 7 ) , : );
        vx = find(Base_Date( : , 1 )==sub_date( 1 , 2 ) & Base_Date( : , 2 )==sub_date( 1 , 3 ));
        num_ltm = Observation( vx , Cola );
        data_ltm = LTM_Data( vx , Cola );
        Repd = Date( Aa( j , 7 ) , : );
        repd = repmat( Repd , length(Cola) , 1 );
        repday = repmat( Aa( j , 7 ) , length(Cola) , 1 );
        
        allb = [ repd  , Cola , repday , Data( Aa( j , 7 ) , Cola)' ,  Z_Scores( Aa( j , 7 ) , Cola)' , data_ltm' ,  num_ltm' ];
        
        miny = min( all( : , 2 ))-1; maxy = max( all( : , 2 ))+1;
        minx = min( all( : , 1 ))-1; maxx = max( all( : , 1 ))+1;
        nn = nn+1;
        info_box{nn} = allb;
        worldmap([ miny , maxy ] , [ minx , maxx ] );
        % Mapping Values Based On Three Conditions.....
        Cxa = isnan(all( : , 3 )); a = all( Cxa , : ); % NaN Values...
        scatterm( a( : , 2 ) , a( : , 1 ) , '.' , 'r');
        
        Cxb = ~isnan( all( : , 3 )); b = all( Cxb , : ); % Rainfall Records...
        scatterm( b( : , 2 ) , b( : , 1 ) , '.' , 'b');
        textm( b( : , 2 ) , b( : , 1 ) , num2str(b( : , 3 ) , 2 ) , 'HorizontalAlignment','right');
        
%         Cxc = all( : , 3 )==0; c = all( Cxc , : ); % Zero Rainfall
%         scatterm( c( : , 2 ) , c( : , 1 ) , '.' , 'g');
        plotm( ostan_lat , ostan_lon);
        String = [ Str , ' & Searching radius ' num2str(Searching_radius(i) , 2) ' Date : ' int2str(Aa( j , 1 )) '-'  int2str(Aa( j , 2 )) '-'  int2str(Aa( j , 3 )) ];
        
        hl = legend( String , 'Location' , 'NorthOutSide');
        %         set( hl , 'FontSize' , 10 );
        set( gcf , 'Color' , 'W');
        set(gcf,'PaperPosition',[ 0 , 0 , 10 , 8 ])
        set(gcf,'Position' , [ 0 , 0 , 10 , 8 ] );
        Pm = '0';
        file_Name = [  'Suspicious_Temperature_record_0' int2str(i) '__', Pm(j<10) , Pm(j<100) , int2str(j) ];
        print( gcf , [ file_Name ] , '-dpng', '-r300');
        close(gcf);
    end
end
return
%
% %%
if sign(Threshold)==1;  File_Name = 'Extreme_Hot_Temperature_Records_0';   end;
if sign(Threshold)==-1; File_Name = 'Extreme_Cold_Temperature_Records_0'; end;

Doubted_Bank = [];
for i = 1:size(Complex , 2 );
    data = Complex{i};
    Cxa = sign(data( : , 11 ))~=sign(Threshold) & data( : , 10 )>=1;
    Aa = data( Cxa , : );
    load([ File_Name , int2str(Searching_radius(i)) ]);
    dis_matrix = (Distance_Box( 1 , Cxa ));
    Doubted_Bank{i} = Aa;
end

Annual = [];
for k = 1:size( Doubted_Bank , 2 );
    Val = Doubted_Bank{k};
    boxe = [ 1:max(Val( : , 9 )) ]';
    Cx = ismember( boxe , Val( : , 9 ) );
    St = boxe(Cx); N = 0;
    for j = 1:length(Val( : , 1 ));
        %         Annual = [];
        %         for year = 1330 : 1395;
        %             Cxa = Date( : , 1)==year;
        Cd = Data( : , Val( j , 9 ) );
        plot(Cd);
        %             Annual = [ Annual ; year ,  nansum(Cd) ];
        %
        %         end
        Pre = cd();
        cd('E:\University_Funded_Project_97_11_10\Processed_Station_Data');
        load('Final_Refined_Temperature_Data_Synop_&_Climate_Stations_97_12_06.mat', 'sname');
        cd(Pre);
        set(gcf,'PaperPosition',[ 0 , 0 , 13 , 8 ])
        set(gcf,'Position' , [ 0 , 0 , 13 , 8 ] );
        %         bar( Annual( : , 1 ) ,  Annual( : , 2 ));
        grid on; box on;
        set( gcf , 'Color' , 'W');
        STN = sname(Val( j , 9 ));
        String = [ 'Lon = '  , num2str(Pos(Val( j , 9 ) , 1 ) , 5 ) ,  ' Lat = ' num2str(Pos(Val( j , 9 ) , 2 ) , 5 ) , '  Name = ' STN ] ;
        hl = legend( strjoin(String) , 'Location' , 'NorthOutSide' );
        set( gca , 'FontName' , 'B Zar' , 'FontSize' , 14);
        set(hl , 'FontName' , 'Helvetica' , 'FontSize' , 12 );
        y_legend = ' -  ';
        yb = ylabel(y_legend);
        set( yb , 'FontName' , 'B Zar' );
        set( gca , 'xtick' , [ 1 : 365*5 : 24837 ]);
        set( gca , 'xticklabel' , [ 1330 : 5 : 1395 ] );
        hold on;
%         scatter(Val( j , 7 ) , Data( j , 8 ) , '+' , 'r');
        Pm = '0';
        ID = Val( j , 9 );
        N = N+1;
        print( gcf , [ 'Suspicious_temperature_station_0' int2str(k) '__', Pm(N<10) , Pm(N<100) , int2str(N) , '__' Pm(ID<10) , Pm(ID<100) , Pm(ID<1000) ,  int2str(ID) ] , '-dpng', '-r300');
        close(gcf);
        disp([ j , k ]);
    end
end












